#data
wagedata = read.table("C:/Users/danie/OneDrive/Master/Sem1/Eco/R solutions/wagedata.csv")

#3.2
lm<-lm(wage ~ educ + exper, data = wagedata)
lm
summary(lm)
plot(wage ~ educ, data = wagedata)
abline(lm);
plot(wage ~ exper, data = wagedata)
abline(lm);
#plot(wage ~ educ + exper, data = wagedata)


#show that.. # !!If the regression contains a constant, the first column of X only contains ones!!
X = matrix(c(rep(1, times=526), wagedata$educ , wagedata$exper),ncol=3);
b_hat <- matrix(c(lm$coefficients['(Intercept)'],lm$coefficients['educ'], lm$coefficients['exper']),ncol=1);
y_hat = X %*% b_hat;
u_hat = wagedata$wage - y_hat

(t(X) %*% u_hat)
(t(y_hat) %*% u_hat)

#second try
(t(predict(lm) %*% residuals(lm)))
(t(coefficients(lm) * sum(residuals(lm))))



#3.3 a
par(mfrow=c(2,1))
plot(wage ~ exper, data = wagedata)
plot(wage ~ I(exper^2), data = wagedata)
plot(log(wage) ~ I(exper^2), data = wagedata)

lm<-lm(wage ~ educ + exper, data = wagedata)
summary(lm)
lm<-lm(wage ~ educ + exper + I(exper^2), data = wagedata)
summary(lm)
lm<-lm(log(wage) ~ educ + exper + I(exper^2), data = wagedata)
summary(lm) 
#R^2 : 0.2252 0.2692 0.3003
#education > experience

#b
lm<-lm(wage ~ exper, data = wagedata)
summary(lm)
plot(lm$coefficients['exper']*wagedata$exper ~wagedata$exper)

lm<-lm(wage ~ educ + exper + I(exper^2), data = wagedata)
summary(lm)
plot((lm$coefficients['exper']*wagedata$exper + lm$coefficients['I(exper^2)']*I(wagedata$exper^2))~wagedata$exper)

lm<-lm(log(wage) ~ educ + exper + I(exper^2), data = wagedata)
summary(lm)
plot((lm$coefficients['exper']*wagedata$exper + lm$coefficients['I(exper^2)']*I(wagedata$exper^2))~wagedata$exper)

#Experience 30 has the highest value (influence)

#3.5
lm<-lm(log(wage) ~ educ - 1, data = wagedata)
summary(lm)
plot(log(wage) ~ educ, data = wagedata)
abline(lm, col="blue")
lmtest<- lm(log(wage) ~ educ, data=wagedata)
abline(lmtest, col="red")

x <- wagedata$educ
y <- log(wagedata$wage)
(b_hat = sum(x * y) / sum(x^2))
lm$coefficients['educ']
abline(0, b_hat)

X = matrix(c(wagedata$educ),ncol=1);
b_hat <- matrix(c(lm$coefficients['educ']),ncol=1);

y_hat = X %*% b_hat;
u_hat = log(wagedata$wage) - y_hat

(r_squared_non_centered = 1 - ( sum(u_hat^2) / sum(log(wagedata$wage)^2) ))

#3.6
lm<-lm(log(wage) ~ educ, data = wagedata)

X = matrix(c(wagedata$educ),ncol=1);
b_hat <- matrix(c(lm$coefficients['educ']),ncol=1);

y_hat = X %*% b_hat;
u_hat = log(wagedata$wage) - y_hat

(r_squared_non_centered = 1 - ( sum(u_hat^2) / sum(log(wagedata$wage)^2) ))
summary(lm)

